blob: 341a163416e70af5a9b0565f9466266305343241 [file] [log] [blame]
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +01001#!/bin/bash
2
Damien Martin-Guillerezf88f4d82015-09-25 13:56:55 +00003# Copyright 2014 The Bazel Authors. All rights reserved.
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +01004#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000017# This script bootstraps building a Bazel binary without Bazel then
18# use this compiled Bazel to bootstrap Bazel itself. It can also
19# be provided with a previous version of Bazel to bootstrap Bazel
20# itself.
21# The resulting binary can be found at output/bazel.
David Mankin5cafe132015-05-28 20:20:56 +000022
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010023set -o errexit
24
25cd "$(dirname "$0")"
26
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000027source scripts/bootstrap/buildenv.sh
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010028
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000029function usage() {
Kristina Chodorow84450b82016-01-28 15:16:02 +000030 [ -n "${1:-compile}" ] && echo "Invalid command(s): $1" >&2
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000031 echo "syntax: $0 [command[,command]* [BAZEL_BIN [BAZEL_SUM]]]" >&2
32 echo " General purpose commands:" >&2
Kristina Chodorow84450b82016-01-28 15:16:02 +000033 echo " compile = compile the bazel binary (default)" >&2
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000034 echo " Commands for developers:" >&2
Kristina Chodorow84450b82016-01-28 15:16:02 +000035 echo " all = compile,determinism,test" >&2
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000036 echo " determinism = test for stability of Bazel builds" >&2
37 echo " test = run the full test suite of Bazel" >&2
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010038 exit 1
39}
40
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000041function parse_options() {
Kristina Chodorow84450b82016-01-28 15:16:02 +000042 local keywords="(compile|all|determinism|bootstrap|test)"
43 COMMANDS="${1:-compile}"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000044 [[ "${COMMANDS}" =~ ^$keywords(,$keywords)*$ ]] || usage "$@"
45 DO_COMPILE=
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000046 DO_CHECKSUM=
47 DO_FULL_CHECKSUM=1
48 DO_TESTS=
Kristina Chodorow84450b82016-01-28 15:16:02 +000049 [[ "${COMMANDS}" =~ (compile|all) ]] && DO_COMPILE=1
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000050 [[ "${COMMANDS}" =~ (bootstrap|determinism|all) ]] && DO_CHECKSUM=1
51 [[ "${COMMANDS}" =~ (bootstrap) ]] && DO_FULL_CHECKSUM=
52 [[ "${COMMANDS}" =~ (test|all) ]] && DO_TESTS=1
53
54 BAZEL_BIN=${2:-"bazel-bin/src/bazel"}
Damien Martin-Guillerez4f892812015-07-02 08:38:58 +000055 BAZEL_SUM=${3:-"x"}
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010056}
57
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000058parse_options "${@}"
Kristina Chodorow8c6b3bb2015-04-09 19:05:34 +000059
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000060mkdir -p output
61: ${BAZEL:=${2-}}
Kristina Chodorowac271142015-03-06 16:00:46 +000062
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000063#
64# Create an initial binary so we can host ourself
65#
66if [ ! -x "${BAZEL}" ]; then
67 display "$INFO You can skip this first step by providing a path to the bazel binary as second argument:"
68 display "$INFO $0 ${COMMANDS} /path/to/bazel"
69 new_step 'Building Bazel from scratch'
70 source scripts/bootstrap/compile.sh
Kristina Chodorowdccd81f2016-02-01 17:42:07 +000071 # The DO_COMPILE flow will actually create the bazel binary and set BAZEL.
72 DO_COMPILE=1
Daniel Wagner-Hall13ba3312015-03-20 05:45:45 +000073fi
74
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000075#
76# Bootstrap bazel using the previous bazel binary = release binary
77#
Damien Martin-Guillereza377af02015-06-24 12:04:27 +000078if [ "${EMBED_LABEL-x}" = "x" ]; then
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000079 # Add a default label when unspecified
80 git_sha1=$(git_sha1)
81 EMBED_LABEL="head (@${git_sha1:-non-git})"
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010082fi
83
Damien Martin-Guillerez3d796fe2016-01-11 10:07:57 +000084if [[ $PLATFORM == "darwin" ]] && \
85 xcodebuild -showsdks 2> /dev/null | grep -q '\-sdk iphonesimulator'; then
86 EXTRA_BAZEL_ARGS="${EXTRA_BAZEL_ARGS-} --define IPHONE_SDK=1"
Dmitry Lomovac6ed792015-12-22 19:24:00 +000087fi
Damien Martin-Guillerez3d796fe2016-01-11 10:07:57 +000088source scripts/bootstrap/bootstrap.sh
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +010089
Lukacs Berki0d5d5222015-10-12 13:24:44 +000090if [ $DO_COMPILE ]; then
91 new_step 'Building Bazel with Bazel'
92 display "."
Damien Martin-Guillerez50fce862016-01-18 11:30:10 +000093 log "Building output/bazel"
Dmitry Lomov9d40a602016-02-15 16:15:03 +000094 bazel_build "src:bazel${EXE_EXT}"
95 cp -f "bazel-bin/src/bazel${EXE_EXT}" "output/bazel${EXE_EXT}"
96 chmod 0755 "output/bazel${EXE_EXT}"
97 BAZEL="$(pwd)/output/bazel${EXE_EXT}"
Lukacs Berki0d5d5222015-10-12 13:24:44 +000098fi
99
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000100#
101# Output is deterministic between two bootstrapped bazel binary using the actual tools and the
102# released binary.
103#
104if [ $DO_CHECKSUM ]; then
105 new_step "Determinism test"
Damien Martin-Guillerez4349f942015-06-24 13:28:08 +0000106 if [ ! -f ${BAZEL_SUM:-x} ]; then
107 BAZEL_SUM=bazel-out/bazel_checksum
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000108 log "First build"
109 bootstrap_test ${BAZEL} ${BAZEL_SUM}
110 else
111 BOOTSTRAP=${BAZEL}
112 fi
113 if [ "${BAZEL_SUM}" != "${OUTPUT_DIR}/bazel_checksum" ]; then
114 cp ${BAZEL_SUM} ${OUTPUT_DIR}/bazel_checksum
115 fi
116 if [ $DO_FULL_CHECKSUM ]; then
117 log "Second build"
118 bootstrap_test ${BOOTSTRAP} bazel-out/bazel_checksum
119 log "Comparing output"
120 (diff -U 0 ${OUTPUT_DIR}/bazel_checksum bazel-out/bazel_checksum >&2) \
121 || fail "Differences detected in outputs!"
122 fi
123fi
Han-Wen Nienhuysd08b27f2015-02-25 16:45:20 +0100124
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000125#
126# Tests
127#
128if [ $DO_TESTS ]; then
129 new_step "Running tests"
130 display "."
Lukacs Berki678ba232015-09-03 13:28:55 +0000131
Damien Martin-Guillerezb81f90c2015-09-04 15:52:26 +0000132 ndk_target="$(get_bind_target //external:android_ndk_for_testing)"
133 sdk_target="$(get_bind_target //external:android_sdk_for_testing)"
134 if [ "$ndk_target" = "//:dummy" -o "$sdk_target" = "//:dummy" ]; then
Lukacs Berki678ba232015-09-03 13:28:55 +0000135 display "$WARNING Android SDK or NDK are not set in the WORKSPACE file. Android tests will not be run."
136 fi
137
Damien Martin-Guillerez338dc562015-06-23 17:15:12 +0000138 [ -n "$JAVAC_VERSION" ] || get_java_version
139 if [[ ! "${BAZEL_TEST_FILTERS-}" =~ "-jdk8" ]] \
140 && [ "8" -gt ${JAVAC_VERSION#*.} ]; then
141 display "$WARNING Your version of Java is lower than 1.8!"
142 display "$WARNING Deactivating Java 8 tests, please use a JDK 8 to fully"
143 display "$WARNING test Bazel."
144 if [ -n "${BAZEL_TEST_FILTERS-}" ]; then
145 BAZEL_TEST_FILTERS="${BAZEL_TEST_FILTERS},-jdk8"
146 else
147 BAZEL_TEST_FILTERS="-jdk8"
148 fi
149 fi
Damien Martin-Guillerez50d124b2015-06-24 15:20:09 +0000150 $BAZEL --bazelrc=${BAZELRC} --nomaster_bazelrc test \
Damien Martin-Guillerez338dc562015-06-23 17:15:12 +0000151 --test_tag_filters="${BAZEL_TEST_FILTERS-}" \
Damien Martin-Guillerez7cf300e2015-06-16 12:31:03 +0000152 --build_tests_only \
Damien Martin-Guillerez8e2adfb2016-01-19 09:01:11 +0000153 --nolegacy_bazel_java_test \
Damien Martin-Guillerez3d796fe2016-01-11 10:07:57 +0000154 ${EXTRA_BAZEL_ARGS} \
Damien Martin-Guillerezd6f48082015-06-05 10:50:43 +0000155 --javacopt="-source ${JAVA_VERSION} -target ${JAVA_VERSION}" \
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000156 -k --test_output=errors //src/... //third_party/ijar/... //scripts/... \
Oscar Boykinb5d417d2016-02-12 21:16:13 +0000157 //tools/build_defs/scala/test/... \
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000158 || fail "Tests failed"
Damien Martin-Guillerezd6f48082015-06-05 10:50:43 +0000159fi
160
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000161clear_log
162display "Build successful! Binary is here: ${BAZEL}"